// Turbo51-Unit
// timer interrupt and trigger 
// J. Rathlev, Jan. 2011

unit Timer;

interface

{$I CpuClock.inc}
const
  Const10ms = - CpuClock div 12 div 100;

// init timer, DeltaTime = multiple of 10 ms 
procedure InitTimer (DeltaTime : byte);

// Check trigger flag
function TimeTrigger : boolean;

// timer interrupt - 10 ms
procedure TimerInt; Interrupt Timer0;

implementation

var
  Period  : byte; volatile;
  TCount  : byte; volatile;
  TimFlag : boolean; volatile;

procedure TimerInt; Assembler;
{begin
  TL0:=Lo(Const10ms);
  TH0:=Hi(Const10ms);
  Dec (TCount);
  if TCount=0 then begin
    TCount:=Period;
    TimFlag:=true;
    end;      }  
Asm
  MOV     TL0,#Low(Const10ms)
  MOV     TH0,#High(Const10ms)
  DJNZ    TCount,@TiRet
  MOV     TCount,Period
  SETB    TimFlag
@TiRet:      
  end;

Procedure InitTimer (DeltaTime : byte);
begin
  TMOD:=TMOD and $F0 or 1;
  TL0:=Lo(Const10ms);
  TH0:=Hi(Const10ms);
  Period:=DeltaTime;
  TCount:=Period;
  TimFlag:=false;
  TF0:=false;
  TR0:=true;
  ET0:=true;
  end;
  
function TimeTrigger : boolean;
begin
  Result:=TimFlag;
  if Result then TimFlag:=false;
  end;
    
end.