unit Utils;

interface

// wait for 150 s
procedure ShortDelay;

// wait for 2 ms
procedure LongDelay (Count : byte); 

implementation

// Short delay (ca. 150s)
// 302 cycles = 1,66 s on 22,1 MHz
procedure ShortDelay; Assembler;
Asm
    MOV     A,#100      
@ShDLp:  
    DEC     A
    JNZ     @ShDLp
    RET
 end;
 
// Long delay(ca. 2 ms)
// 770*Count+2 cycles = 0,4*Count ms on 22,1 MHz
procedure LongDelay (Count : byte); Assembler;
Asm
    CLR     A
@LgDLp:                  // inner loop: 770 cycles
    INC     A              
    JNZ     @LgDLp
    DJNZ    Count,@LgDLp
    RET
 end;  
 
end.